function RFC822Mauer(message) {
  this.from = "undefined";
  this.to = "undefined";

  this.message = message;
}

// encode rfc822 message
RFC822Mauer.prototype.encode = function() {
  return this.textarea.value;
}

// create interface to edit message
RFC822Mauer.prototype.decode = function(dbody) {
  // remove all child nodes
  while(dbody.firstChild)
    dbody.removeChild(dbody.firstChild);

  this.textarea = document.createElementNS("http://www.w3.org/1999/xhtml", "textarea");
  this.textarea.setAttribute("rows", "32");
  this.textarea.appendChild(document.createTextNode(this.message));

  dbody.appendChild(this.textarea);

}

RFC822Mauer.prototype.send = function(mauerListener) {
  var message = this.textarea.value;

  // get headers
  var mp = new MessageParser();
  var sstream = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
  sstream.setData(message, -1);
  var scstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
  scstream.init(sstream);

  mp.parseMessage(sstream);

  // get body
//  var ws = message.match(/(\r|\n|\r\n){2}/)[0];
//  var body = message.substring(message.indexOf(ws) + ws.length);
  var t=new Array(1);
  var body = mp.getMessage(t);
  var headers = mp.messageHeaders();

  scstream.close();
  sstream.close();

  var url = window.prompt("Enter transportURI", "");
  if(!url)
    return;
  this.to = url;
  this.request = new XMLHttpRequest();
  this.request.open("POST", url, true);

  // set request headers
  for(var i = 0; i < headers.length; i++) {
    var matches = headers[i].match(/^([^\x00-\x20:]+)\s*:\s*(.*)$/);
    this.request.setRequestHeader(matches[1], matches[2]);
  }

  this.request.onreadystatechange = mauerListener;

  this.request.send(body);

}
